/*
 * startupM4.S:
 * Initial reset code and vector table.
 * Simplified flash-base vector table because a uMon based
 * environment will relocate this to ram anyway...
 */
    .syntax unified
//    .arch armv7-m

	#include "config.h"
	#include "warmstart.h"

#ifndef ESTABLISH_DEFAULT_HANDLERS
#define ESTABLISH_DEFAULT_HANDLERS 0
#endif

#ifndef INCLUDE_FLASH_CONFIGURATION
#define INCLUDE_FLASH_CONFIGURATION	0
#endif

	.extern	Default_Handler
	.extern	Hardfault_Handler
	.extern MonStack

	.org 	0

/**********************************************************
 *
 * Hard (i.e. in flash) vector table:
 * Assign initial stack pointer and reset vector, then for
 * the first block of common M4 exceptions, we assign a
 * default handler.  The rest of the vector table is left
 * unpopulated because it is assumed that the application
 * will reassign the vector table to ram anyway using VTOR.
 */
	.long	MonStack + (MONSTACKSIZE-4)	// Stack set to MonStack[]
	.long	Reset_Handler
	.long   Default_Handler		// NMI Handler
	.long   HardFault_Handler	// Hard Fault Handler
	.long   Default_Handler		// MPU Fault Handler
	.long   Default_Handler		// Bus Fault Handler
	.long   Default_Handler		// Usage Fault Handler
	.long   0					// Reserved
	.long   0					// Reserved
	.long   0					// Reserved
	.long   0					// Reserved
	.long   Default_Handler		// SVCall Handler
	.long   Default_Handler		// Debug Monitor Handler
	.long   0					// Reserved
	.long   Default_Handler		// PendSV Handler
	.long   Default_Handler		// SysTick Handler

#if ESTABLISH_DEFAULT_HANDLERS
	// The MK64F puts the flash configuration field
	// at location 0x400.  This makes it difficult to
	// reuse this portion of the vector table, so we
	// just allocate all the table entries to point to
	// the default handler.
	// Note: if there is ever any other assy code written
	// for this, it could be put in this "hole" and the
	// block of default handler pointers could be omitted.
	//
	.long	Default_Handler		// vec[16]
	.long	Default_Handler		// vec[17]
	.long	Default_Handler		// vec[18]
	.long	Default_Handler		// vec[19]
	.long	Default_Handler		// vec[20]
	.long	Default_Handler		// ...
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler
	.long	Default_Handler		// vec[251]
	.long	Default_Handler		// vec[252]
	.long	Default_Handler		// vec[253]
	.long	Default_Handler		// vec[254]
	.long	Default_Handler		// vec[255]
#endif

#if INCLUDE_FLASH_CONFIGURATION
/**********************************************************
 *
 * Flash Configuration Field.
 * NOTE: This MUST be located at 0x400
 * (just after end of vector table)...
 */
	.org	0x400
	.global FlashConfigurationField

FlashConfigurationField:
  	.long	0xFFFFFFFF	// Backdoor comparison key
  	.long	0xFFFFFFFF	//
  	.long	0xFFFFFFFF	// Protection bytes
  	.long	0xFFFFFFFE	// FDPROT | FEPROT | FOPT | FSEC
#endif

/**********************************************************
 *
 * uMon support stuff:
 * Its put here because this location is not likely to
 * move as a result of other things changing in the code.
 * This is important because MONCOMPTR is the well-known
 * address used by the application if it hooks to the uMon
 * API.
 */
    .weak   moncom
	.global moncomptr
moncomptr:
	.long moncom

	.global etheraddr
	.balign 0x10
etheraddr:
	.byte 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
	.byte 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
	.byte 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff


/**********************************************************
 *
 * Reset Handler
 * Call SystemInint and copy initialized data to ram.
 */
    .text
    .thumb
    .thumb_func
    .align 2
	.extern	watchdog_init
	.globl	warmstart
    .globl	Reset_Handler
Reset_Handler:
	bl watchdog_init

/* Loop to copy data from read only memory to RAM. The ranges
 * of copy from/to are specified by following symbols evaluated in
 * linker script.
 * __etext: End of code section, i.e., begin of data sections to copy from.
 * __data_start__/__data_end__: RAM address range that data should be
 * copied to. Both must be aligned to 4 bytes boundary.
 */

	ldr    r1, =__etext
	ldr    r2, =__data_start__
	ldr    r3, =__data_end__
	subs    r3, r2
	ble    .LC1
.LC0:
	subs    r3, #4
	ldr    r0, [r1, r3]
	str    r0, [r2, r3]
	bgt    .LC0
.LC1:

	movs	r0, #INITIALIZE		// Reset enters warmstart with
					// r0= INITIALIZE

/* warmstart may be entered inline by reset or it can be called
 * by appexit().  Either way, the SP is loaded with whatever is in
 * vector 0.  The only difference is what value ends up being passed
 * to start().  For reset, the value (above) is INITIALIZE, but for
 * appexit() it should be APP_EXIT.
 */
warmstart:
	mov.w	r1, #0
	ldr r1, [r1,#0]
	mov sp, r1
	bl	start

    .end
