/* TWR-K60N512 MicroMonitor configuration file.
 */
#define CPU_LE
#define SYSCLKFREQ		50000000
#define PLATFORM_NAME	"TWR-K60N512"
#define CMDLINESIZE		120	
#define getopt umon_getopt

#ifndef ASSEMBLY_ONLY
#define WATCHDOG_MACRO watchdog_refresh()
extern void watchdog_refresh(void);
#endif

#define USR_HEADER_FUNC reset_message

/* Used by startupM4.S...
 */
#define ESTABLISH_DEFAULT_HANDLERS	1
#define INCLUDE_FLASH_CONFIGURATION	1

/* Used by ethernet to make sure things don't
 * start rolling until the link is up...
 */
#define ENET_LINK_IS_UP linkpoll
#define LINKUP_TICK_MAX 10

/* When using an absolute address to access a thumb function 
 * we must add one to the address...
 * (Refer to "pointers to functions in Thumb state" at
 * infocenter.arm.com).
 */
#define ADJUST_THUMB_ADDRESS(a)	(a|1)

#define	DEFAULT_ETHERADD "00:00:00:00:00:00"
#define	DEFAULT_IPADD "192.168.1.100"

/* Flash bank configuration:
 * Basic information needed to configure the flash driver.
 * Fill in port specific values here.
 * The FLASH_PROTECT_RANGE should be set to cover the sectors
 * used by boot.bin burned into flash.
 * You can figure this out by  running
 */
#define PSECTOR_SIZE			0x00000800
#define PBLOCK_SIZE				0x00080000
#define PBLOCK_BASE				0x00000000
#define FLASHBANKS				1
#define FLASH_BANK0_BASE_ADDR  	PBLOCK_BASE
#define FLASH_LARGEST_SECTOR    PSECTOR_SIZE

#define TIMER_TICKS_PER_MSEC	(SYSCLKFREQ/1000)

/* The make file should specify how to build this...
 */
#if BUILD_FOR_UUMON
#include "uumon_config.h"
#elif BUILD_FOR_UMONM
#include "umonm_config.h"
#else
#error: Specify BUILDTYPE in makefile
#endif
